////////////////////////////////////////////////////////////////////////////////
//	ローカライズされた文字列の取得
//		Copyright (C) 2008 - 2009 AAOh inc.
////////////////////////////////////////////////////////////////////////////////

var LANG_JS_SRC     = "localizedStrings.js";
var PARENT_LOCATION = location.toString().substring(0, location.toString().lastIndexOf("/")) + "/";

/**
 * ローカライズの設定。
 *
 * @param lang 言語名
 */
function setLocalized(lang){
	if(lang == null){
		return;
	}
	var jsObjList = document.getElementsByTagName("script");

	for (var cnt = 0; cnt < jsObjList.length; cnt++) {
		var jsSrc = jsObjList[cnt].src;
		if(jsSrc.lastIndexOf(LANG_JS_SRC) < 0){
			continue;
		}

		var jsSrc = null;
		if(lang == "ja"){
			jsSrc = LANG_JS_SRC;
		} else {
			jsSrc = lang + "/" + LANG_JS_SRC;
		}

		if(
			jsObjList[cnt].src == jsSrc
			|| jsObjList[cnt].src == PARENT_LOCATION + jsSrc
		){
			break;
		}

		// 今のjsを削除
		var headObj = jsObjList[cnt].parentNode;
		headObj.removeChild(jsObjList[cnt]);

		// 新しいjsを追加
		var jsObj = document.createElement("script");
		jsObj.src    = jsSrc;
		jsObj.onload = initSettingData;
		headObj.appendChild(jsObj);
		break;
	} // for (var cnt = 0; cnt < jsObjList.length; cnt++)
}

/**
 * ローカライズされた文字列の取得。
 *
 * @param  キー
 * @return ローカライズされた文字列
 */
function getLocalizedString(key) {
	var ret = null;

	try {
		ret = localizedStrings[key];

	} catch(ex) {
	}

	if (ret == null || ret === undefined) {
		ret = key;
	}

	return ret;
}

