////////////////////////////////////////////////////////////////////////////////
//	月齢ガジェット
//		Copyright (C) 2008 - 2009 AAOh inc.
////////////////////////////////////////////////////////////////////////////////

// 設定情報(JSON)
var settingData = {
	"moonage"    : "moonage1",
	"bg"         : "onDoc1",
	"bgUnDoc"    : "unDoc1",
	"lang"       : "ja",
	"chkUpdTime" : 0,
	"chkUpdUrl"  : null
};

var iid = null;

var flgOnDoc = true;

var updChkIid = null;

/**
 * 月の名前の取得。
 *
 * @param age 月齢
 */
function getMoonName(age){
	var moonName = null;

	//if(age - 0.5 <= 0 || age + 0.5 > MONNAGE_NEW)
	if(age - 0.5 >= 0 && age - 0.5 < 1.0){
		// 新月
		moonName = getLocalizedString("TTL_NEW");

	} else if(age - 0.5 <= MONNAGE_WAXING && age + 0.5 > MONNAGE_WAXING){
		// 上弦
		moonName = getLocalizedString("TTL_WAXING");

	} else if(age - 0.5 <= MONNAGE_FULL && age + 0.5 > MONNAGE_FULL){
		// 満月
		moonName = getLocalizedString("TTL_FULL");

	} else if(age - 0.5 <= MONNAGE_WANING && age + 0.5 > MONNAGE_WANING){
		// 下弦
		moonName = getLocalizedString("TTL_WANING");

	} else {
		moonName = "&nbsp;";

	} // if(age <= 0 || age + 0.5 > MONNAGE_NEW)

	return moonName;
}

/**
 * 月のイメージ番号の取得。
 *
 * @param age 月齢
 */
function getMoonImageNumber(age){
	var moonNum  = 0;

	if(age - 0.5 <= 0 || age + 0.5 > MONNAGE_NEW){
		// 新月
		moonNum  = 0;

	} else if(age - 0.5 <= MONNAGE_WAXING && age + 0.5 > MONNAGE_WAXING){
		// 上弦
		moonNum  = 4;

	} else if(age - 0.5 <= MONNAGE_FULL && age + 0.5 > MONNAGE_FULL){
		// 満月
		moonNum  = 8;

	} else if(age - 0.5 <= MONNAGE_WANING && age + 0.5 > MONNAGE_WANING){
		// 下弦
		moonNum  = 12;

	} else {
		moonNum  = parseInt(16 / 29.530588853 * age);

	} // if(age + 1 > MONNAGE_NEW)

	return moonNum;
}

/**
 * 月齢表示。
 */
function showMoonage(){
	if(iid != null){
		clearTimeout(iid);
		iid = null;
	}

	showAge();

	// 次回更新設定
	iid = setTimeout('showMoonage()', INTERVAL);
}

/**
 * 月齢表示。
 */
function showAge(){
	// 月齢計算
	var age      = moonage(new Date());
	var moonAge  = parseInt(age * 10) / 10;
	var moonName = getMoonName(moonAge);
	var moonNum  = getMoonImageNumber(moonAge);

	moonAge = String(moonAge);
	if(moonAge.indexOf(".") < 0){
		moonAge = moonAge + ".0";
	}

	// 月齢表示
	$("lbl_moonage").innerHTML = moonName;
	var img = $("img_moonage");
	img.src   = IMG_SRC_NOON1 + moonNum + IMG_SRC_NOON2;
	img.alt   = moonAge;
	img.title = moonAge;
	$("lbl_moonage2").innerHTML = "(" + moonAge + ")";
}

/**
 * カレンダー表示。
 */
function showCalender(){
	if(iid != null){
		clearTimeout(iid);
		iid = null;
	}

	// 初期設定の設定
	var date = new Date();
	$("hid_year").value  = date.getFullYear();
	$("hid_month").value = (date.getMonth() + 1);

	showMonthAge(0);

	// 次回更新設定
	iid = setTimeout('showCalender()', INTERVAL);
}

/**
 * カレンダー表示。
 *
 * @param sub 今月からの差
 */
function showMonthAge(sub){
	// 日付オブジェクトの生成
	var year  = $("hid_year").value;
	var month = $("hid_month").value;
	var cal   = new Date(year, month - 1 + sub, 1);

	// 年月の表示
	year  = cal.getFullYear();
	month = cal.getMonth() + 1;
	$("hid_year").value          = year;
	$("hid_month").value         = month;
	$("lbl_yearmonth").innerHTML = year + getLocalizedString("YEAR_NAME")
		+ month + getLocalizedString("MONTH_NAME");
	$("lbl_sun").innerHTML       = getLocalizedString("SUN_NAME");
	$("lbl_mon").innerHTML       = getLocalizedString("MON_NAME");
	$("lbl_tue").innerHTML       = getLocalizedString("TUE_NAME");
	$("lbl_wed").innerHTML       = getLocalizedString("WED_NAME");
	$("lbl_thu").innerHTML       = getLocalizedString("THU_NAME");
	$("lbl_fri").innerHTML       = getLocalizedString("FRI_NAME");
	$("lbl_sat").innerHTML       = getLocalizedString("SAT_NAME");

	var tmpDate = new Date(cal.getTime());
	tmpDate.setMonth(tmpDate.getMonth() + 1);
	tmpDate.setTime(tmpDate.getTime() - 86400000);

	var nowDate = new Date();

	var firstDay = cal.getDay() + 1;
	var lastDate = tmpDate.getDate();
	var dateCnt  = 1;
	for(var weekCnt = 1 ; weekCnt <= 6 ; weekCnt++){
		for(var dayCnt = 1 ; dayCnt <= 7 ; dayCnt++){
			var date     = null;
			var today    = null;
			var moonName = null;
			var moonNum  = null;
			var moonAge  = null;

			if(
				weekCnt == 1 && dayCnt < firstDay
				|| dateCnt > lastDate
			){
				// 空表示
				date     = "&nbsp;";
				today    = "";
				moonName = "";
				moonNum  = 99;
				moonAge  = 99;

			} else {
				// 月齢計算
				date = String(dateCnt);

				// 今日の判定
				if(
					cal.getFullYear() == nowDate.getFullYear()
					&& cal.getMonth() == nowDate.getMonth()
					&& dateCnt == nowDate.getDate()
				){
					today = "today";
				} else {
					today = "";
				}

				cal.setDate(dateCnt);
				var age  = moonage(cal);
				moonAge  = parseInt(age * 10) / 10;
				moonName = getMoonName(moonAge);
				moonNum  = getMoonImageNumber(moonAge);

				moonAge = String(moonAge);
				if(moonAge.indexOf(".") < 0){
					moonAge = moonAge + ".0";
				}

				dateCnt++;
			}

			$("lbl_date_" + weekCnt + "_" + dayCnt).innerHTML    = date;
			$("lbl_date_" + weekCnt + "_" + dayCnt).className    = today;
			$("lbl_moonage_" + weekCnt + "_" + dayCnt).innerHTML = moonName;
			var img = $("img_moonage_" + weekCnt + "_" + dayCnt);
			img.src = IMG_SRC_NOON1 + moonNum + IMG_SRC_NOON2;

			var moonAge2 = null;
			if(moonAge < 99){
				img.alt   = moonAge;
				img.title = moonAge;
				moonAge2  = "(" + moonAge + ")";
			} else {
				img.alt   = "";
				img.title = "";
				moonAge2  = "&nbsp;";
			}
			$("lbl_moonage2_" + weekCnt + "_" + dayCnt).innerHTML = moonAge2;

		} // for(var dayCnt = 1 ; dayCnt <= 7 ; dayCnt++)
	} // for(var weekCnt = 1 ; weekCnt <= 5 ; weekCnt++)
}

/**
 * 設定画面が表示されたとき。
 */
function doSetting(){
	// 特になし
}

/**
 * 設定画面が閉じられた時。
 */
function doSettingClosed(){
	// 設定情報の読込み
	readData();

	if(flgOnDoc){
		showOnDoc();
	} else {
		showUnDoc();
	}
}

/**
 * フォーカス設定。
 */
function setFocus(){
	// ボタンが連打できないようにする
	$("bdy_moonage").focus();
}

/**
 * スライドバーにドックされたとき。
 */
function showOnDoc(){
	$("bdy_moonage").className       = settingData.moonage;
	$("div_moonage").className       = settingData.bg;
	$("div_moonage_undoc").className = "hide";

	// なぜかクラス設定では反映されないのでここで設定
	document.body.style.width  = WINDOW_VISTA_WIDTH + "px";
	document.body.style.height = WINDOW_HEIGHT + "px";
	if(!isVista()){
		document.body.style.width  = WINDOW_WIDTH + "px";
	}

	showMoonage();

	flgOnDoc = true;
}

/**
 * スライドバーからアンドックされたとき。
 */
function showUnDoc(){
	$("bdy_moonage").className       = settingData.moonage;
	$("div_moonage").className       = "hide";
	$("div_moonage_undoc").className = settingData.bgUnDoc;

	// なぜかクラス設定では反映されないのでここで設定
	document.body.style.width  = WINDOW_UNDOC_WIDTH + "px";
	document.body.style.height = WINDOW_UNDOC_HEIGHT + "px";

	showCalender();

	flgOnDoc = false;
}

/**
 * 月齢計算。
 *
 * @param  date 対象日
 * @return      月齢
 */
function moonage(date){
	var age = 0;

	// 月齢 = ユリウス日 - 直近の新月
	date.setHours(12);
	date.setMinutes(0);
	date.setSeconds(0);
	date.setMilliseconds(0);

	var julianDate = date.getTime() / 86400000.0 + 2440587.5;

	var k       = Math.floor((julianDate - 2451550.09765) / 29.530588853);
	var t       = k / 1236.85;
	var newDate = 2451550.09765
		+ 29.530588853  * k
		+ 0.0001337     * t * t
		- 0.40720       * Math.sin((201.5643 + 385.8169 * k) * 0.017453292519943)
		+ 0.17241       * Math.sin((  2.5534 +  29.1054 * k) * 0.017453292519943);

	age = julianDate - newDate;

	// 補正
	if(age > 29.530588853){
		age = 29.530588853;

	} else if(age < 0){
		age = 29.530588853 + age;
	}

	return age;
}

/**
 * 設定情報の初期化。
 */
function initSettingData(){
	// 画面表示の設定
	if(flgOnDoc){
		showOnDoc();
	} else {
		showUnDoc();
	}
}

/**
 * 更新チェックするか。
 *
 * @return 更新チェックするときにはtrue
 */
function isCheckUpdate(){
	var flgChkUpd = false;

	// 未チェックだったら必ずtrue
	if(settingData.chkUpdTime <= 0){
		return true;
	}

	// 更新イメージ表示中だったら必ずtrue
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		return true;
	}

	var nowDate   = new Date();
	var nextDate  = new Date(settingData.chkUpdTime);

	// 1ヶ月後を設定
	nextDate.setMonth(nowDate.getMonth() + UPDATE_INTERVAL_MONTH);

	if(nowDate.getTime() > nextDate.getTime()){
		// 更新チェックを行う
		flgChkUpd = true;
	}

	return flgChkUpd;
}

/**
 * 更新なしイメージの設定。
 */
function showUpdateNon(){
	var aUpd = $("a_upd");
	if(aUpd == null){
		var imgUpd = $("img_upd");
		imgUpd.src   = IMG_SRC_UPDATE_NON;
		imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE_NON");
		imgUpd.title = getLocalizedString("IMG_ALT_UPDATE_NON");

	} else {
		var divUpd     = $("td_upd");
		var imgUpdHtml = divUpd.innerHTML;
		divUpd.innerHTML
			= '<img src="' + IMG_SRC_UPDATE_NON + '" name="img_upd" id="img_upd" '
			+ 'alt="' + getLocalizedString("IMG_ALT_UPDATE_NON") + '" '
			+ 'title="' + getLocalizedString("IMG_ALT_UPDATE_NON") + '" border="0">';
	}
}

/**
 * チェック中イメージの設定。
 */
function showUpdateNow(){
	var aUpd = $("a_upd");
	if(aUpd == null){
		var imgUpd = $("img_upd");
		imgUpd.src   = IMG_SRC_UPDATE_NOW;
		imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE_NOW");
		imgUpd.title = getLocalizedString("IMG_ALT_UPDATE_NOW");

	} else {
		var divUpd     = $("td_upd");
		var imgUpdHtml = divUpd.innerHTML;
		divUpd.innerHTML
			= '<img src="' + IMG_SRC_UPDATE_NOW + '" name="img_upd" id="img_upd" '
			+ 'alt="' + getLocalizedString("IMG_ALT_UPDATE_NOW") + '" '
			+ 'title="' + getLocalizedString("IMG_ALT_UPDATE_NOW") + '" border="0">';
	}
}

/**
 * 更新イメージの設定。
 */
function showUpdate(){
	var imgUpd = $("img_upd");
	imgUpd.src   = IMG_SRC_UPDATE;
	imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE");
	imgUpd.title = getLocalizedString("IMG_ALT_UPDATE");

	var aUpd = $("a_upd");
	if(aUpd == null){
		// dashboard対応
		var onclickFnuc = "";
		if(isDashboard()){
			onclickFnuc = ' onclick="window.widget.openURL(this.href); return false;"';
		} // if(isDashboard())

		var divUpd = $("td_upd");
		var imgUpdHtml = divUpd.innerHTML;
		divUpd.innerHTML = '<a id="a_upd" href="' + settingData.chkUpdUrl +'"' + onclickFnuc + '>' + imgUpdHtml + '</a>';

	} else {
		aUpd.href = settingData.chkUpdUrl;
	}
}

/**
 * 更新チェック。
 * 更新チェックはPC起動時または1日毎に行う。
 */
function checkUpdate(){
	if(updChkIid != null){
		clearTimeout(updChkIid);
		updChkIid = null;
	}

	try{
		doCheckUpdate();
	}catch(ex){
	}
	updChkIid = setTimeout('checkUpdate()', UPDATE_CEHCK_INTERVAL_TIME);
}

/**
 * 更新表示。
 */
function doCheckUpdate(){
	// 更新イメージの初期設定
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		showUpdate();

	} else {
		showUpdateNon();
	}

	// 更新チェックするか
	var flgChkUpd = isCheckUpdate();
	if(!flgChkUpd){

		// 今回は更新チェックを行わない
		return;
	}

	// 現在のバージョンの取得
	var nowVer = getVersion();
	if(nowVer == null || nowVer == ""){

		// 今回は更新チェックを行わない
		return;
	}

	// 更新イメージをチェック中にする
	showUpdateNow();

	// Firefox対応
	try{
		if(netscape){
			netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
		}
	}catch (ex){
	}

	var updateUrl = null;
	if(isOpera()){
		updateUrl = OPERA_UPDATE_URL;

	} else if(isDashboard()){
		updateUrl = DASHBOARD_UPDATE_URL;

	} else if(isSBM()){
		updateUrl = SBM_UPDATE_URL;

	} else {
		updateUrl = VISTA_UPDATE_URL;
	}

/*
	// 非同期だとうまく動作しない
	var chkUpdReq = new Ajax.Request(
		updateUrl, {
			method       : "get",
			parameters   : "name=" + GADGET_NAME + "&version=" + nowVer + "&time=" + new Date().getTime(),
//			onLoaded     : function(){
//				// 更新イメージをチェック中にする
//				var imgUpd = $("img_upd");
//				imgUpd.src   = IMG_SRC_UPDATE_NOW;
//				imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE_NOW");
//				imgUpd.title = getLocalizedString("IMG_ALT_UPDATE_NOW");
//			},
			//onComplete   : showCheckUpdate,
			asynchronous : false,
			onFailure    : checkUpdateError,
			onException  : checkUpdateException
		}
	);
*/

	// 最新バージョンの取得
	var parameters = "name=" + GADGET_NAME + "&version=" + nowVer + "&time=" + new Date().getTime();
	var resTxt     = null;
	try{
		// Ajax通信
		// 非同期だとうまく動作しない
		resTxt = ajax.gets(updateUrl + "?" + parameters);

	}catch(ex){
		checkUpdateError(ex);
		return;
	}

	// レスポンスを作成
/*
	var chkUpdRes = new Ajax.Response(chkUpdReq);
	showCheckUpdate(chkUpdRes);
*/
	showCheckUpdate(resTxt);
}

/**
 * 更新表示。
 *
 * @param resTxt レスポンスオブジェクト
 */
function showCheckUpdate(resTxt){
	var flgUpd = false;

	// 更新チェックデータの取得
	var chkUpdData = null;
	if(resTxt != null){
		try{
			//chkUpdData = resTxt.evalJSON();
			chkUpdData = JSON.parse(resTxt);

		}catch(ex){
			checkUpdateException(ex);
			return;
		}
	}

	if(
		chkUpdData == null
		|| chkUpdData[GADGET_NAME] == null
	){
		// 更新イメージを元に戻す
		if(
			settingData.chkUpdUrl != null
			&& settingData.chkUpdUrl != ""
		){
			showUpdate();

		} else {
			showUpdateNon();
		}
		return;
	}

	// 現在のバージョンの取得
	var nowVer = getVersion();
	if(nowVer == null || nowVer == ""){

		// 今回は更新チェックを行わない
		// 更新イメージを元に戻す
		if(
			settingData.chkUpdUrl != null
			&& settingData.chkUpdUrl != ""
		){
			showUpdate();

		} else {
			showUpdateNon();
		}
		return;
	}

	// バージョンチェック
	if(nowVer != chkUpdData[GADGET_NAME].version){
		var nowVerList = nowVer.split(".");
		var updVerList = chkUpdData[GADGET_NAME].version.split(".");
		for(var cnt = 0 ; cnt < nowVerList.length ; cnt++){
			if(cnt >= updVerList.length){
				break;
			}

			var nowVerSub = parseInt(nowVerList[cnt]);
			var updVerSub = parseInt(updVerList[cnt]);
			if(nowVerSub < updVerSub){
				flgUpd = true;
				break;

			} else if(nowVerSub > updVerSub){
				break;
			}
		} // for(var cnt = 0 ; cnt < nowVerList.length ; cnt++)
	}

	// 更新イメージ設定
	if(flgUpd){
		settingData.chkUpdUrl = chkUpdData[GADGET_NAME].url;

		// 更新イメージにする
		showUpdate();

	} else {
		settingData.chkUpdUrl = null;

		// 更新なしイメージにする
		showUpdateNon();
	}


	// 更新チェック日付の更新
	settingData.chkUpdTime = new Date().getTime();
	writeData();
}

/**
 * Ajaxエラー。
 *
 * @param res レスポンスオブジェクト
 */
function checkUpdateError(res){
	// 更新イメージを元に戻す
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		showUpdate();

	} else {
		showUpdateNon();
	}
}

/**
 * Ajaxエラー。
 *
 * @param res レスポンスオブジェクト
 */
function checkUpdateException(res, ex){
	// 更新イメージを元に戻す
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		showUpdate();

	} else {
		showUpdateNon();
	}
}

/**
 * バージョン情報の取得。
 */
function getVersion(){
	var ver = "";

	try{
		//ver = System.Gadget.version;
		ver = VERSION;

	}catch(ex){
	}

	return ver;
}

/**
 * 設定情報の読込み。
 *
 * @return 読込んだ設定情報
 */
function getReadData(){
	var readValue = null;

	try{
		if(!isVista()){
			readValue = widget.preferenceForKey(SETTING_NAME);

		} else {
			readValue = System.Gadget.Settings.readString(SETTING_NAME);
		}
	}catch(ex){
	}

	var readData_ = null;
	if(readValue != null && readValue != ""){
		try{
			//readData_ = readValue.evalJSON();
			readData_ = JSON.parse(readValue);

		}catch(ex){
		}
	}

	return readData_;
}

/**
 * 設定情報の読込み。
 */
function readData(){
	var readData_ = getReadData();

	if(readData_ != null && readData_ != ""){
		settingData = readData_;
	}
}

/**
 * 設定情報の書込み。
 *
 * @param writeData 書込む設定情報
 */
function setWriteData(writeData){
	try{
		//var writeValue = Object.toJSON(writeData);
		var writeValue = JSON.stringify(writeData);

		if(!isVista()){
			widget.setPreferenceForKey(writeValue, SETTING_NAME);

		} else {
			System.Gadget.Settings.writeString(SETTING_NAME, writeValue);
		}
	}catch(ex){
	}
}

/**
 * 設定情報の書込み。
 */
function writeData(){
	setWriteData(settingData);
}

/**
 * 初期処理。
 */
function init(){
	setEventListener();
	setGadgetEventListener();
	readData();

	// ソフトバンクモバイルかの判定
	if(!isSBM()){

		// 設定画面の読込み
		$("if_setting").src = "moonage-setting.html";

	} else {
		setMobilePhone();
	}

	// 画面表示の設定
	setLocalized(settingData.lang);
	initSettingData();
	if(FLG_UPDATE){
		checkUpdate();
	}
	setFocus();
}

/**
 * イベントリスナーの設定。
 */
function setEventListener(){
	// onclickの設定
	$("btn_pre").onclick       = function(){ showMonthAge(-1); setFocus(); };
	$("btn_next").onclick      = function(){ showMonthAge(1);  setFocus(); };
	$("lbl_yearmonth").onclick = function(){ showCalender();   setFocus(); };
}

/**
 * ガジェットイベントリスナーの設定。
 */
function setGadgetEventListener(){
	try{
		flgOnDoc = System.Gadget.docked;

		// ドックの状態設定
		System.Gadget.onDock   = showOnDoc;
		System.Gadget.onUndock = showUnDoc;

		// 設定画面の設定
		System.Gadget.settingsUI        = "moonage-setting.html";
		System.Gadget.onShowSettings    = doSetting;
		System.Gadget.onSettingsClosed  = function(){ doSettingClosed(); setFocus(); };

	}catch(ex){
		// ツールバーの表示
		$("td_setting").className = "";

		// 最大化ボタン(unDoc)
		if(isMobile()){
			$("btn_max").className = "hide";

		} else {
			$("btn_max").onclick = function(){
				if(flgOnDoc){
					showUnDoc();
					window.resizeTo(WINDOW_UNDOC_WIDTH, WINDOW_UNDOC_HEIGHT);

				} else {
					showOnDoc();
					window.resizeTo(WINDOW_WIDTH, WINDOW_HEIGHT);
				}
			};
		} // if(isMobile())

		// 設定ボタン
		if(!!window.JSON){
			$("btn_conf").onclick = function(){
				doSetting();
				$("if_setting").className        = "";
				$("btn_max").className           = "hide";
				$("div_moonage").className       = "hide";
				$("div_moonage_undoc").className = "hide";

				if(isMobile()){
					document.body.style.width  = WINDOW_SETTING_MOBILE_WIDTH + "px";
					document.body.style.height = WINDOW_SETTING_MOBILE_HEIGHT + "px";
					window.resizeTo(WINDOW_SETTING_MOBILE_WIDTH, WINDOW_SETTING_MOBILE_HEIGHT);
				} else {
					document.body.style.width  = WINDOW_SETTING_WIDTH + "px";
					document.body.style.height = WINDOW_SETTING_HEIGHT + "px";
					window.resizeTo(WINDOW_SETTING_WIDTH, WINDOW_SETTING_HEIGHT);
				} // if(isMobile())
			}

		} else {
			$("btn_conf").className = "hide";
		}

		if(isOpera()){
				// 閉じるボタン
				$("btn_close").onclick = function(){
					window.close();
				};

		} else {
			$("btn_close").className = "hide";
		}
	}
}

/**
 * ソフトバンクモバイル用設定。
 */
function setMobilePhone(){
	FLG_UPDATE = false;
	$("div_toolbar").className = "hide";

	WINDOW_WIDTH  = 240;
	WINDOW_HEIGHT = 240;

	$("img_moonage").width  = "144px";
	$("img_moonage").height = "144px";
}

// 初期処理
document.body.onload = init();

